;RMMCVAf[^őM
;Receiving remocon signal and serial-output
;RMMCʂTrbgGPIOɏo͂
;Receiving remocon signal and output lower-5bit from GPIO
;                  by I.N.
; Device:PIC12F629/683  CLK=Internal(4MHz) (VCC=2`5V)
;
; 2016.11.22 ver.0.1 38400bpso('0'/'1')mF
; 2016.11.24 ver.1.0 iNEC,SONY(12-20bit),AEHA(48bit)j
; 2017.01.04-05 ver.1.1 remocon.asm𗬗pCGPIOo͔łɂ
;                    VAM͂Ȃ
; 2017.01.10 ver.2.0 SAMSUNG,FUNAIǉ,AEHA(repeat)̏C
; 2017.01.11 ver.3.0 VICTORǉ

; [GPIOłŏo͂f[^]
; NEC tH[}bg   FDATA2
; VICTORtH[}bg FDATA1
; SAMSUNGtH[}bgFDATA2
; AEHAtH[}bg   FDATA4
; FUNAItH[}bg  FDATA1
; SONYtH[}bg   FDATA0

; 
;   G    F     E    D 
;  GND   GP0    GP1   GP2 
;     PIC12F629/675/683   
;  VDD   GP5    GP4   GP3 
;   @    A    B    C  
; 

; GP3:Input only 
; FPA.EXE 啶C͋ʂ
;       64bit Windowsł͎słȂ

    include 12f6xx.h
    .16f84 ;o`xăAZu܂B

    ;12F629̐ݒFIV[^(GPIO),PWRT-ON,WDT-OFF,MCLR-internal (0x3184)

    ;12F683̐ݒFFOSC=INTOSCIO, WDTE=Disable, PWRTE=Enable, MCLRE=GP3=I/O, 
    ;              CP=Not_Protect, CPD=Not_Protect, BODEN=Disable, IESO=Disable, 
    ;              FCMEN=Disable (0x30C4)

    .pwrt on      ;̃RtBO[V͂PUeWS
    .osc intrc    ;ƈႤ̂łqnlC^[œǂ񂾌C
    .mclre disable
    .wdt off

; GPIO.2 --- RS-232C output (txd)
; GPIO.3 --- Remocon signal intput from SPS-440-1
SIGNAL  equ gpio.3
TXD     equ gpio.2
BIT0    equ gpio.0
BIT1    equ gpio.1
BIT2    equ gpio.2
BIT3    equ gpio.4
BIT4    equ gpio.5

    ;SRAM start address
    org 20h

TM1    ds 1
TM2    ds 1
TM3    ds 1
CH     ds 1  ; MMf[^iWrbgj
CH2    ds 1  ; GPIOo͗piTrbgjbit0,1,2,4,5
RS     ds 1  ; EFCgԒp
CN     ds 1  ; rbg
VICT   ds 1  ; VICTORs[g`FbNp

TCNT   ds 1  ;T̃JEgp
BUF    ds 1  ;MrbgƗp
BITCNT ds 1  ;MrbgJE^
DATA0  ds 1  ;Mf[^0
DATA1  ds 1  ;Mf[^1
DATA2  ds 1  ;Mf[^2
DATA3  ds 1  ;Mf[^3
DATA4  ds 1  ;Mf[^4
DATA5  ds 1  ;Mf[^5

    ;EEPROM start address
    ;---ZbgxN^̐ݒ
    org 0 
    jmp start

    ;---荞݃xN^̐ݒ
    org 4
    retfie

    ;------------------------------------------------
start
    ;U(4MHz)̃Lu[V for 12F629
    ;*** 12F683ł͈ȉSsRg邱 ***
    ;setb rp0
    ;call 3FFh      ;Get the cal value
    ;movwf osccal   ;Calibrate
    ;clrb rp0

    clrb rp0
    mov cmcon,#7    ;ڰ sgp

    setb rp0
    mov ansel,#0         ;A/Dsgp fW^
    mov trisio,#001000b  ;I/O setting (1=in, 0=out)
    mov intcon,#0        ;荞ݕsgp
    ;mov wpu,#110111b    ;ٱ(1:enable)
    clrb rp0

    ;GPIO initialization
    ;--- serial output---
    setb TXD
    ;---GPIO output---
    ;;mov gpio,#0

    ;---LED test---
    ;call led_test

    ;ӉH肷܂ł̃EFCg
    mov W,#1
    call WAIT2

    ;----------烁C[v----------
    ; NEC) 1T = 56us
cont
    ;---detect Leader---
    clr VICT
VICTOR_cont
    clr BITCNT
    clr TCNT
label10
    jb SIGNAL,label10
label10b                 ;Total:56us
    call INC_T           ;48us
label11
    jb SIGNAL,label12    ;2us
    cja TCNT,#180,cont   ;4us
    jmp label10b         ;2us
label12
    cjae TCNT,#142,leaderA_detected         ;NEC/VICTOR format (142=8.0ms)
    cjae TCNT,#75,SAMSUNG_leaderA_detected  ;SAMSUNG format    ( 75=4.2ms)
    cjae TCNT,#53,AEHA_leaderA_detected     ;AEHA/FUNAI format ( 53=3.0ms)
    cjae TCNT,#32,SONY_leaderA_detected     ;SONY format       ( 32=1.8ms)
VICTOR_repeat_check
	jb VICT.0,leaderB_detected
    jmp cont

    ;------------------NEC/VICTOR format---------------
	; NEC=32bit   VICTOR=16bit
leaderA_detected
    clr TCNT
label20
    call INC_T            ;48us
label21
    jnb SIGNAL,label22    ;2us
    cja TCNT,#90,cont     ;4us
    jmp label20           ;2us
label22
    cjae TCNT,#70,leaderB_detected
    cjae TCNT,#30,repeat_detected
    jmp cont

repeat_detected
    ;s[g𑗐M
    ;--- serial output---
    mov CH, #'n'
    call transmit
    ;---GPIO output---
    ;No action
label30
    jnb SIGNAL,label30
    jmp cont

leaderB_detected
label40
    jnb SIGNAL,label40
    clr TCNT
label41
    call INC_T                ;48us
label42
    jnb SIGNAL,label43        ;2
    cja TCNT,#40,VICTOR_check ;4 (40=4T)
    jmp label41               ;2
label43
    cjae TCNT,#20,bit1_detected   ;4

bit0_detected
    clc                   ;1
    jmp label50           ;2
bit1_detected
    stc                   ;1
    jmp label50           ;2
label50
    rr BUF                ;1
    inc BITCNT            ;1
    cje BITCNT,#8 ,set_data0
    cje BITCNT,#16,set_data1
    cje BITCNT,#24,set_data2
    cje BITCNT,#32,set_data3
label51
    jnb SIGNAL,label51
    jmp label40

set_data0
    mov DATA0,BUF        ;2
    jmp label51

set_data1
    mov DATA1,BUF        ;2
    jmp label51

set_data2
    mov DATA2,BUF        ;2
    jmp label51

set_data3
    mov DATA3,BUF        ;2
label60
    jnb SIGNAL,label60
    ;--- serial output---
    mov CH, #'N'
    call transmit
    mov CH,DATA0
    call transmit
    mov CH,DATA1
    call transmit
    mov CH,DATA2
    call transmit
    mov CH,DATA3
    call transmit
    ;---GPIO output---
    ;;mov CH,DATA2
    ;;call output5
    jmp cont

VICTOR_check
    cje BITCNT,#16,VICTOR_detected
    jmp cont
VICTOR_detected
    ;--- serial output---
    mov CH, #'V'
    call transmit
    mov CH,DATA0
    call transmit
    mov CH,DATA1
    call transmit
    ;---GPIO output---
    ;;mov CH,DATA1
    ;;call output5
	setb VICT.0
    jmp VICTOR_cont


    ;------------------SAMSUNG format---------------
    ;1T=0.568us
SAMSUNG_leaderA_detected
    clr TCNT
SAMSUNG_label20
    call INC_T                 ;48us
SAMSUNG_label21
    jnb SIGNAL,SAMSUNG_label22 ;2
    cja TCNT,#91,cont          ;4 (91=9T)
    jmp SAMSUNG_label20        ;2
SAMSUNG_label22
    cja TCNT,#71,SAMSUNG_leaderB_detected  ;(71=7T)
    jmp cont

SAMSUNG_rep_chk
    cje BITCNT,#1,SAMSUNG_repeat_detected
    jmp cont
SAMSUNG_repeat_detected
    ;s[g𑗐M
    ;--- serial output---
    mov CH, #'g'
    call transmit
    ;---GPIO output---
    ;No action
SAMSUNG_label30
    jnb SIGNAL,SAMSUNG_label30
    jmp cont

SAMSUNG_leaderB_detected
SAMSUNG_label40
    jnb SIGNAL,SAMSUNG_label40
    clr TCNT
SAMSUNG_label41
    call INC_T                     ;48us
SAMSUNG_label42
    jnb SIGNAL,SAMSUNG_label43     ;2
    cja TCNT,#41,SAMSUNG_rep_chk   ;4 (41=4T)
    jmp SAMSUNG_label41            ;2
SAMSUNG_label43
    cja TCNT,#20,SAMSUNG_bit1_detected    ;4 (20=2T)

SAMSUNG_bit0_detected
    clc                    ;1
    jmp SAMSUNG_label50    ;2
SAMSUNG_bit1_detected
    stc                    ;1
    jmp SAMSUNG_label50    ;2
SAMSUNG_label50
    rr BUF                 ;1
    inc BITCNT             ;1
    cje BITCNT,#8 ,SAMSUNG_set_data0
    cje BITCNT,#16,SAMSUNG_set_data1
    cje BITCNT,#24,SAMSUNG_set_data2
    cje BITCNT,#32,SAMSUNG_set_data3
SAMSUNG_label51
    jnb SIGNAL,SAMSUNG_label51
    jmp SAMSUNG_label40

SAMSUNG_set_data0
    mov DATA0,BUF        ;2
    jmp SAMSUNG_label51

SAMSUNG_set_data1
    mov DATA1,BUF        ;2
    jmp SAMSUNG_label51

SAMSUNG_set_data2
    mov DATA2,BUF        ;2
    jmp SAMSUNG_label51

SAMSUNG_set_data3
    mov DATA3,BUF        ;2
SAMSUNG_label60
    jnb SIGNAL,SAMSUNG_label60
    ;--- serial output---
    mov CH, #'G'
    call transmit
    mov CH,DATA0
    call transmit
    mov CH,DATA1
    call transmit
    mov CH,DATA2
    call transmit
    mov CH,DATA3
    call transmit
    ;---GPIO output---
    ;;mov CH,DATA2
    ;;call output5

    jmp cont


    ;------------------AEHA/FUNAI format---------------
    ; AEHA) 1T=0.425ms   FUNAI) 1Tf=0.873ms
AEHA_leaderA_detected
    clr TCNT
AEHA_label20
    call INC_T                ;48us
AEHA_label21
    jnb SIGNAL,AEHA_label22   ;2
    cja TCNT,#68,cont         ;4 (68=9T)
    jmp AEHA_label20          ;2
AEHA_label22
    cja TCNT,#47,FUNAI_leaderB_detected ;(47=3Tf)
    cja TCNT,#23,AEHA_leaderB_detected  ;(23=3T)
    jmp cont

AEHA_repeat_detected
    ;s[g𑗐M
    ;--- serial output---
    mov CH, #'a'
    call transmit
    ;---GPIO output---
    ;No action
AEHA_label30
    jnb SIGNAL,AEHA_label30
    jmp cont

AEHA_leaderB_detected
AEHA_label40
    jnb SIGNAL,AEHA_label40
    clr TCNT
AEHA_label41
    call INC_T                ;48us
AEHA_label42
    jnb SIGNAL,AEHA_label43   ;2
    cja TCNT,#40,cont         ;4
    jmp AEHA_label41          ;2
AEHA_label43
    cja TCNT,#15,AEHA_bit1_detected    ;4

AEHA_bit0_detected
    clc                   ;1
    jmp AEHA_label50      ;2
AEHA_bit1_detected
    stc                   ;1
    jmp AEHA_label50      ;2
AEHA_label50
    rr BUF                ;1
    inc BITCNT            ;1
    cje BITCNT,#8 ,AEHA_set_data0
    cje BITCNT,#16,AEHA_set_data1
    cje BITCNT,#24,AEHA_set_data2
    cje BITCNT,#32,AEHA_set_data3
    cje BITCNT,#40,AEHA_set_data4
    cje BITCNT,#48,AEHA_set_data5
AEHA_label51
    jnb SIGNAL,AEHA_label51
    jmp AEHA_label40

AEHA_set_data0
    mov DATA0,BUF        ;2
    jmp AEHA_label51

AEHA_set_data1
    mov DATA1,BUF        ;2
    jmp AEHA_label51

AEHA_set_data2
    mov DATA2,BUF        ;2
    jmp AEHA_label51

AEHA_set_data3
    mov DATA3,BUF        ;2
    jmp AEHA_label51

AEHA_set_data4
    mov DATA4,BUF        ;2
    jmp AEHA_label51

AEHA_set_data5
    mov DATA5,BUF        ;2
AEHA_label60
    jnb SIGNAL,AEHA_label60
    ;--- serial output---
    mov CH, #'A'
    call transmit
    mov CH,DATA0
    call transmit
    mov CH,DATA1
    call transmit
    mov CH,DATA2
    call transmit
    mov CH,DATA3
    call transmit
    mov CH,DATA4
    call transmit
    mov CH,DATA5
    call transmit
    ;---GPIO output---
    ;;mov CH,DATA4
    ;;call output5

    jmp cont


    ;------------------FUNAI format---------------
    ; 1T=0.873ms     4bit+8bit and inverted 12bit
FUNAI_leaderB_detected
FUNAI_label40
    jnb SIGNAL,FUNAI_label40
    clr TCNT
FUNAI_label41
    call INC_T                          ;48us
FUNAI_label42
    jnb SIGNAL,FUNAI_label43            ;2
    cja TCNT,#62,AEHA_repeat_detected   ;4 (62=4T)
    jmp FUNAI_label41                   ;2
FUNAI_label43
    cja TCNT,#31,FUNAI_bit1_detected    ;4 (31=2T)

FUNAI_bit0_detected
    clc                   ;1
    jmp FUNAI_label50     ;2
FUNAI_bit1_detected
    stc                   ;1
    jmp FUNAI_label50     ;2
FUNAI_label50
    rr BUF                ;1
    inc BITCNT            ;1
    cje BITCNT,#6 ,FUNAI_set_data0
    cje BITCNT,#12,FUNAI_set_data1
    cje BITCNT,#18,FUNAI_set_data2
    cje BITCNT,#24,FUNAI_set_data3
FUNAI_label51
    jnb SIGNAL,FUNAI_label51
    jmp FUNAI_label40

FUNAI_set_data0
    clc
    rr BUF
    clc
    rr BUF
    mov DATA0,BUF        ;2
    jmp FUNAI_label51

FUNAI_set_data1
    clc
    rr BUF
    clc
    rr BUF
    mov DATA1,BUF        ;2
    jmp FUNAI_label51

FUNAI_set_data2
    stc
    rr BUF
    stc
    rr BUF
    mov DATA2,BUF        ;2
    jmp FUNAI_label51

FUNAI_set_data3
    stc
    rr BUF
    stc
    rr BUF
    mov DATA3,BUF        ;2
FUNAI_label60
    jnb SIGNAL,FUNAI_label60
    ;--- serial output---
    mov CH, #'F'
    call transmit
    mov CH,DATA0
    call transmit
    mov CH,DATA1
    call transmit
    mov CH,DATA2
    call transmit
    mov CH,DATA3
    call transmit
    ;---GPIO output---
    ;;mov CH,DATA1
    ;;call output5

    jmp cont


    ;------------------SONY format---------------
SONY_leaderA_detected
    clr BUF
    clr TCNT
SONY_label20
    call INC_T              ;48us
SONY_label21
    jnb SIGNAL,SONY_label22 ;2
    cja TCNT,#21,cont       ;4 (<2T)
    jmp SONY_label20        ;2
SONY_label22
    cja TCNT,#5,SONY_leaderB_detected    ;(>0.5T)
    jmp cont

SONY_leaderB_detected
    clr TCNT
SONY_label41
    call INC_T              ;48us
SONY_label42
    jb SIGNAL,SONY_label43  ;2
    cja TCNT,#32,cont       ;4 (>3T)
    jmp SONY_label41        ;2
SONY_label43
    cja TCNT,#16,SONY_bit1_detected    ;4 (>1.5T)

SONY_bit0_detected
    clc                   ;1
    jmp SONY_label50      ;2
SONY_bit1_detected
    stc                   ;1

SONY_label50
    rr BUF                ;1
    inc BITCNT            ;1
    cje BITCNT,#7 ,SONY_set_data0
    cje BITCNT,#15,SONY_set_data1
SONY_label51
    clr TCNT
SONY_label52
    call INC_T                          ;48us
SONY_label53
    jnb SIGNAL,SONY_leaderB_detected    ;2
    cja TCNT,#32,SONY_data_end          ;4 (>3T)
    jmp SONY_label52                    ;2

SONY_data_end
    cjbe BITCNT,#11,cont
    ;--- serial output---
    mov CH, #'S'
    call transmit
    mov CH,DATA0
    call transmit
    ;---GPIO output---
    ;;mov CH,DATA0    ;;
    ;;call output5    ;;
    cjbe BITCNT,#14,SONY_send0
    cje BITCNT,#15,SONY_send1

SONY_send2
    cje BITCNT,#23,SONY_send2b
    clc
    rr BUF
    inc BITCNT
    jmp SONY_send2
SONY_send2b
    ;--- serial output---
    mov CH,DATA1    ;;
    call transmit   ;;
    mov CH,BUF      ;;
    call transmit   ;;
    jmp cont

SONY_send1
    ;--- serial output---
    mov CH,DATA1      ;;
    call transmit     ;;
    clr CH            ;dummy data    ;;
    call transmit     ;;
    jmp cont

SONY_send0
    cje BITCNT,#15,SONY_send0b
    clc
    rr BUF
    inc BITCNT
    jmp SONY_send0
SONY_send0b
    ;--- serial output---
    mov CH,BUF        ;;
    call transmit     ;;
    clr CH            ;dummy data    ;;
    call transmit     ;;
    jmp cont

SONY_set_data0
    clc
    rr BUF
    mov DATA0,BUF        ;2
    clr BUF
    jmp SONY_label51

SONY_set_data1
    mov DATA1,BUF        ;2
    clr BUF
    jmp SONY_label51

    ;----------C[v̂----------


;---TCNTCNg0.1T҂Cv(48cycle)---
                    ;2(call)
INC_T
    inc TCNT        ;1
    mov TM1,#14     ;2
inct10
    djnz TM1,inct10 ;3*14-1
    ret             ;2


;*************GPIOo̓Tu[`(쐬2017/01/05)***************
; CH  f[^oCgZbgăR[
; o͉͂̂5rbĝ
output5
    ;---bit0---
    rr CH
    rr CH2
    ;---bit1---
    rr CH
    rr CH2
    ;---bit2---
    rr CH
    rr CH2
    ;---bit3---
    rr CH2
    rr CH
    rr CH2
    ;---bit4---
    rr CH
    rr CH2
    rr CH2
    rr CH2
    mov gpio,CH2
    ret

    ;***** LED test *****
led_test
    mov gpio,#000001b
    mov W,#1
    call WAIT2
    mov gpio,#000010b
    mov W,#1
    call WAIT2
    mov gpio,#000100b
    mov W,#1
    call WAIT2
    mov gpio,#010000b
    mov W,#1
    call WAIT2
    mov gpio,#100000b
    mov W,#1
    call WAIT2
    mov gpio,#000000b
    ret

;*************RS232CMTu[`(쐬2016/11/22)***************
;Internal oscilator: 4MHz
;1MHz/38400bps=26.04cycle (26cycle...0.16%)
; CH  f[^oCgZbgăR[

;---StartBit---
transmit
        clrb TXD          ;1
        mov RS,#6         ;2
trans10
        djnz RS,trans10   ;6*3-1=17
        mov CN,#8         ;2
        nop               ;1
        nop               ;1

transmit0
        rr CH             ;1
        movb TXD,c        ;4 f[^óiLSBj
        mov RS,#5         ;2
trans11
        djnz RS,trans11   ;5*3-1=14
        nop               ;1
        nop               ;1
        djnz CN,transmit0 ;3(2)

        nop               ;1
        nop               ;1
        nop               ;1
;---StopBit---
        setb TXD          ;1
        mov RS,#7         ;2
trans12
        djnz RS,trans12   ;7*3-1=20
        nop               ;1
        ret               ;2


    ;---EFCg֐(NX^4MHzp)--- p[^FW
    ;cycle = (mov:1)+(call:2)+1+(1+2)*TM1-1+(ret:2)
    ;      = 5+3*W
WAIT1
        mov TM1,W
LB11    djnz TM1,LB11
        ret


    ;---EFCg֐(NX^4MHzp)iW*0.1bj--- p[^FW
    ;cycle = (mov:1)+(call:2)+1+(2+(2+(5+1+2)*TM3-1+1+2)*TM2-1+1+2)*TM1-1+(ret:2)
    ;      = ((8*TM3+4)*TM2+4)*TM1+5
WAIT2
        mov TM1,W
LB1     mov TM2,#54
LB2     mov TM3,#231
LB3     nop
        nop
        nop
        nop
        nop
        djnz    TM3,LB3
        djnz    TM2,LB2
        djnz    TM1,LB1
        ret

