// PICvO"remcn3.asm"̓ǂݎƕ\
//                by I.N.

// 2016.11.22 ver.1.0 (NEC)
// 2016.11.24 ver.1.1 AEHA, SONY̒ǉ
// 2017.01.10 ver.1.2 SAMSUNG/FUNAI̒ǉ
// 2017.01.11 ver.1.3 VICTOR̒ǉ

#include <esplib.h>
#include <erslib.h>
int ncom=4;

void ESP_Ready(void)
{
	// ESPLIB --- Automatic Source Generator
	// [Text Window]
	ESP_OpenTextWindow(0,418,63,424,300);
	// [Main Window]
	ESP_PlaceMain(469,400);
	ESP_SetForeground(ESPMAINWINDOW);
	ESP_START=1;
}

void ESP_Main(void)
{
	int count=0;
	unsigned char buf[32];
	char *str[6]={
		"N4:NEC",
		"V2:VICTOR",
		"G4:SAMSUNG",
		"A6:AEHA",
		"F4:FUNAI",
		"S3:SONY"
	};

	int r;
	r=ERS_Open(ncom,4096,4096);
	if(r){
		ESP_Printf("com open error.\n");
		return;
	}
	ERS_BaudRate(ncom,38400);
	ESP_Printf("Start\n");

	for(;;){
		if(ESP_STOP) break;

		if(ERS_CheckRecv(ncom)>0){
			int c= ERS_Getc(ncom);

			ESP_Printf("%04d : ",count++);

			for(int i=0;i<6;i++){
				if(c==str[i][0]){
					ESP_Printf("[%s] ",&str[i][3]);
					int bytes= str[i][1]-'0';
					ERS_Recv(ncom,buf,bytes);
					for(int k=0; k<bytes; k++){
						ESP_Printf("%02Xh ",buf[k]);
					}
					ESP_Printf("\n");
				}else if(c==str[i][0]+32){
					ESP_Printf("[%s] Repeat\n",&str[i][3]);
				}
			}

		}
	}

	ERS_Close(ncom);
	ESP_Printf("End\n");
}

void ESP_Finish(void)
{
}

